package rocketBugsRender;
/*
	HistoPlotFrame ... plots HistogramPlus
*/

/*  <RocketBugsRender - for rendering and graphing the output of Zoom (and other programs)>
    Copyright (C) <2007>  <Jonathan B. Alberts>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

import java.awt.*;
import java.awt.event.*;
import java.lang.Math;
import javax.swing.*;
import javax.swing.event.*;
import java.io.*;
import java.text.*;
import java.util.*;

public class HistoPlotter extends JFrame implements ChangeListener, ActionListener, WindowListener, ComponentListener, KeyListener, MouseListener, MouseMotionListener, AdjustmentListener {
	HistogramPlus curHist;
	HistoPlotPanel hPanel;
	Dimension curSize = new Dimension (501,250);

	public HistoPlotter () {
		setSize(curSize);
		setLocation(500,0);
		
		hPanel = new HistoPlotPanel(this);
		
		addKeyListener(this);
		addComponentListener(this);
		addMouseListener(this);
		addMouseMotionListener(this);
		addWindowListener(this);
		
		initialize();
		show();
	}

	public void initialize () {
		this.show();
		getContentPane().removeAll();
		getContentPane().setLayout(new BorderLayout());
		//getContentPane().add (titlePanel, BorderLayout.NORTH);
		getContentPane().add (hPanel, BorderLayout.CENTER);
		//getContentPane().add (continuePanel, BorderLayout.SOUTH);		
		hPanel.initialize(curSize);
	}
	
	public void arrayScale (HistogramPlus [] hists) {
		hPanel.autoScale(hists);
	}
	
	public void setYScale (double scaleFac) {
		hPanel.setYScale(scaleFac);
	}


	public void plotHist (HistogramPlus hist, boolean scaleEach) {
		hPanel.clearImage();
		hPanel.showName(hist.name + " " + hist.unitsString);
		if (scaleEach) { hPanel.autoScale(hist); }
		hPanel.plotHist(hist);
	
	}
	
	public void showName (String nameString) {
		hPanel.showName(nameString);
	}
		

	public void actionPerformed (ActionEvent e) {
		String act = e.getActionCommand();
	}
	
	public void stateChanged(ChangeEvent e) {
        JSlider source = (JSlider)e.getSource();
    }
	
	public void adjustmentValueChanged (AdjustmentEvent e) {
	}
	
	
	public void windowActivated (WindowEvent e) {}
	public void windowClosing (WindowEvent e) {}
	public void windowDeactivated (WindowEvent e) {}
	public void windowDeiconified (WindowEvent e) {}
	public void windowIconified (WindowEvent e) {}
	public void windowOpened (WindowEvent e) {}
	public void windowClosed (WindowEvent e) {}
	
	public void keyReleased (KeyEvent e) {}
	public void keyTyped (KeyEvent e) {}
	public void keyPressed (KeyEvent e) {
		String act = e.getKeyText(e.getKeyCode());
	}
	
	public void mouseClicked (MouseEvent e) {}
	public void mouseEntered (MouseEvent e) {}
	public void mouseExited (MouseEvent e) {}
	public void mousePressed (MouseEvent e) {
		int xPos = e.getX();
		int yPos = e.getY();
	}
	
	public void mouseReleased (MouseEvent e) {}
	public void mouseDragged (MouseEvent e) {}
	public void mouseMoved (MouseEvent e) {}
	
	public void componentHidden (ComponentEvent e) {}
	public void componentShown (ComponentEvent e) {}
	public void componentMoved (ComponentEvent e) {}
	public void componentResized (ComponentEvent e) {}
	
}